*
      SUBROUTINE CAL_SYEVZ(NAME, UPLO, N, NPROW, NPCOL, AMEM, MEMSIZE,
     $                     NB, VL, VU, IL, IU, ABSTOL, ORFAC,
     $                     INFILEA, OUTFILE)
*
*      (PDSYEV2, PDSYEV4, PDSYEV6)
*       
*   QL  QR - 
*
      include 'mpif.h'
*
*  
      INTEGER            N, NPROW, NPCOL, NB, MEMSIZE, IL, IU
      DOUBLE PRECISION   AMEM( MEMSIZE ), VL, VU, ABSTOL,ORFAC
      CHARACTER*(*)      INFILEA, OUTFILE, NAME, UPLO
*
*   -  
      INTEGER            NOUT, NIN, NPR
      PARAMETER          ( NOUT =13, NIN = 11, NPR = 6 )
*
*  
      INTEGER            ANB, CTXT, CONTEXTC, I, IAM, INFO, IPA, IPEV,
     $                   IPGAP, IPFAIL, IPCLUSTR, IPW, IPWOR, IPIWOR,
     $                   IPZ, NP, NQ, M, MYCOL, MYROW, MXNP, MXNQ,
     $                   NEIG, NN, NZ,
     $                   LWOPT, LWORK, LIWORK, IA, JA, IZ, JZ,
     $                   NPROCS, NPS, NSYTRD, MMIN, SQNPC, WORKSIZ
*
*  
      INTEGER            DESCA( 9 ), DESCZ( 9 )
*
*  
      EXTERNAL           ICEIL, ILCM, NUMROC, PDLAMCH, PDLANGE,
     $                   SL_GRIDRESHAPE, PJLAENV
      INTEGER            ICEIL, ILCM, NUMROC, SL_GRIDRESHAPE, PJLAENV
      DOUBLE PRECISION   PDLAMCH, PDLANGE
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDLAPRNT, PDLAREAD,
     $                   PDLAWRITE,
     $                   PDSYEV2, PDSYEV4, PDSYEV6
*
*  
      INTRINSIC          ABS, DBLE, MAX, MIN, MOD, SQRT, INT
*
*  
*
*  
*
      IA = 1
      JA = 1
      IZ = 1
      JZ = 1
*
*   BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
*
        IF( NPROCS.LT.1 ) THEN
           CALL BLACS_SETUP( IAM, NPROCS )
*           CALL BLACS_SETUP( IAM, NPROW*NPCOL )
        END IF
*
*   BLACS'   
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
*
       NP = NUMROC( N, NB, MYROW, 0, NPROW )
       NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
*
*      A, Z
*
      CALL DESCINIT(DESCA, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
      CALL DESCINIT(DESCZ, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
*
*     AMEM
*
*     A
      IPA = 1
*
*   EV ( )
      IPEV = IPA + DESCA(9)*NQ
*
      IF( NAME .NE. 'PDSYEV4' .AND. NAME .NE. 'PDSYEV6' ) GOTO 2
*
      IPGAP = IPEV + N
      IPFAIL = IPGAP + NPROW*NPCOL
      IPCLUSTR = IPFAIL + N
*     Z (  )
      IPZ = IPCLUSTR + NPROW*NPCOL
*     WORK
      IPWOR = IPZ + DESCZ(9)*NQ
*
*   ,    PDSYEV4(6)
*
      NP0 = NUMROC( N, NB, 0, 0, NPROW )
      MQ0 = NUMROC( N, NB, 0, 0, NPCOL )
*
      NN = MAX( N, NB, 2 )
*
      NEIG = N
      IF( NAME .NE. 'PDSYEV6' ) GOTO 1
*
      NEIG = IU - IL + 1
*
    1 MQ0 = NUMROC( MAX( NEIG, NB, 2 ), NB, 0, 0, NPCOL )
      LWMIN = 5*N + MAX( 5*NN, NP0*MQ0+2*NB*NB ) +
     $                 ICEIL( NEIG, NPROW*NPCOL )*NN
      LWOPT = LWMIN
*
      ANB = PJLAENV( CTXT, 3, 'PDSYTTRD', 'L', 0, 0, 0, 0 )
      SQNPC = INT( SQRT( DBLE( NPROW*NPCOL ) ) )
      NPS = MAX( NUMROC( N, 1, 0, 0, SQNPC ), 2*ANB )
      NSYTRD_LWOPT = 2*( ANB+1 )*( 4*NPS+2 ) + ( NPS+4 )*NPS
      LWOPT = MAX( LWOPT, 5*N+NSYTRD_LWOPT )
*
      LWORK = LWOPT
*
      LIWORK = 6*MAX( N, NPROCS+1, 4 )
*
*     IWORK
      IPIWOR = IPWOR + LWORK
      IPW = IPIWOR + LIWORK
*
      GOTO 3
*
    2 IF( NAME .NE. 'PDSYEV2' ) GOTO 10
*
*   ,    PDSYEV2
*
      IPZ = IPEV + N
*     WORK
      IPWOR = IPZ + DESCZ(9)*NQ
* 
      SIZEMQRLEFT = MAX( (NB*( NB-1 ))/2, (NP+NQ)* NB ) + NB*NB
*
      LDC = 0
      CONTEXTC = SL_GRIDRESHAPE( DESCA( 2 ), 0, 1, 1, NPROCS, 1 )
      CALL BLACS_GRIDINFO( CONTEXTC, NPROWC, NPCOLC, MYPROWC,
     $                              MYPCOLC )
      NRC = NUMROC( N, NB, MYPROWC, 0, NPROCS)
      LDC = MAX( 1, NRC )
*
      CALL BLACS_GRIDEXIT( CONTEXTC )
*
      QRMEM = 2*N-2
      LWORK = 5*N + N*LDC + MAX( SIZEMQRLEFT, QRMEM ) + 1
*
      IPW = IPWOR + LWORK
*
      GOTO 3
*
*     PDLAPRNT  .
*
    3 WORKSIZ = MAX( NB, NP )
*
*        
*
      INFO = 0
      MMIN = IPW + WORKSIZ
*
*      ( MMIN )
*
      IF(IPW + WORKSIZ .GT. MEMSIZE ) THEN
         IF( IAM .EQ. 0 ) WRITE( NPR, FMT = * )'  '
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         INFO = 1
      END IF
*
*   INFO    
*
      CALL IGSUM2D( CTXT, 'All', ' ', 1, 1, INFO, 1, -1, 0 )
      IF( INFO .GT. 0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 )
     $       WRITE( NOUT, FMT = * ) '   '
         GO TO 10
      END IF
*
*      
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )N, N, NB, NB
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NPR, FMT = * ) '     '
         WRITE( NPR, FMT = * )'   IPA,   IPEV,  IPWOR,   IPW,  MMIN'
         WRITE( NPR, FMT = 9994 )IPA, IPEV, IPWOR, IPW, MMIN
*
         IF( NAME .NE. 'PDSYEV4' .AND. NAME .NE. 'PDSYEV6' ) GOTO 4
         WRITE( NPR, FMT = * )'   IPZ    ANB   NPS  LWORK  LIWORK'
         WRITE( NPR, FMT = 9994 ) IPZ, ANB, NPS, LWORK, LIWORK
    4    WRITE( NPR, FMT = * ) '  DESCA'
         WRITE( NPR, FMT = 9985 )DESCA
         WRITE( NPR, FMT = * ) '  DESCZ'
         WRITE( NPR, FMT = 9985 )DESCZ
    5    WRITE( NPR, FMT = * ) '  A'
      END IF
*
*        A
*
      CALL PDLAREAD(INFILEA, AMEM(IPA), DESCA, 0, 0, AMEM(IPW))
*
 9994 FORMAT( / 5I7 /)
 9985 FORMAT( / 9I5 /)
*
      CALL PDLAPRNT( N, N, AMEM(IPA), IA, JA, DESCA, 0, 0, 'A',
     $               NPR, AMEM( IPW ) )
*
*     
*
      IF( NAME .EQ. 'PDSYEV4' ) GOTO 12
      IF( NAME .EQ. 'PDSYEV6' ) GOTO 14
      IF( NAME .NE. 'PDSYEV2' ) GOTO 10
*
      CALL PDSYEV2( UPLO, N, AMEM(IPA), IA, JA, DESCA, AMEM(IPEV),
     $             AMEM(IPZ), IZ, JZ, DESCZ, AMEM(IPWOR), LWORK, INFO)
      GOTO 99
*
   14 CALL PDSYEV6( UPLO, N, AMEM(IPA), IA, JA, DESCA, IL, IU, ABSTOL,
     $             M, NZ, AMEM(IPEV), ORFAC, AMEM(IPZ), IZ, JZ, DESCZ,
     $              AMEM(IPWOR), LWORK, AMEM(IPIWOR), LIWORK,
     $              AMEM(IPFAIL), AMEM(IPCLUSTR), AMEM(IPGAP), INFO )
      GOTO 99
*
   12 CALL PDSYEV4( UPLO, N, AMEM(IPA), IA, JA, DESCA, VL, VU, ABSTOL,
     $             M, NZ, AMEM(IPEV), ORFAC, AMEM(IPZ), IZ, JZ, DESCZ,
     $              AMEM(IPWOR), LWORK, AMEM(IPIWOR), LIWORK,
     $              AMEM(IPFAIL), AMEM(IPCLUSTR), AMEM(IPGAP), INFO )
      GOTO 99
*
*  
*
   99 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
         WRITE( NPR, FMT = 9995 )INFO, UPLO
       IF( NAME .NE. 'PDSYEV3' .AND. NAME .NE. 'PDSYEV4' ) GOTO 15
         WRITE( NPR, FMT = 9991 ) VL, VU
   15  IF( NAME .NE. 'PDSYEV5' .AND. NAME .NE. 'PDSYEV6' ) GOTO 16
         WRITE( NPR, FMT = 9989 ) IL, IU
         WRITE( NPR, FMT = 9993 ) ABSTOL
         WRITE( NPR, FMT = 9990 ) M
   16    IF( NAME .NE. 'PDSYEV4' .AND. NAME .NE. 'PDSYEV6' ) GOTO 17
         WRITE( NPR, FMT = 9988 ) NZ
*
*         WRITE( NPR, FMT = 9984 )AMEM(IPW)
*
   17   WRITE( NPR, FMT = * ) '  '
        NEX = N
        IF(NAME .EQ. 'PDSYEV2') GOTO 11
*
        NEX = M
   11   DO 18 I = IPEV, IPEV+NEX-1
        PRINT *, ' W(', I-IPEV+1, ')=', AMEM( I ), ';'
   18   CONTINUE
      END IF
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  Z (  )'
      END IF
*
 9989 FORMAT( / ' IL = ', I5, ' IU = ', I5 / )
 9991 FORMAT( / ' VL = ', D20.12, ' VU = ', D20.12 / )
 9993 FORMAT( / ' ABSTOL = ', D20.12 /)
 9990 FORMAT( / ' M = ', I5 /)
 9988 FORMAT( / ' NZ = ', I5 /)
*
      IF( NAME .NE. 'PDSYEV4' .AND. NAME .NE. 'PDSYEV6' ) GOTO 19

      CALL PDLAPRNT( N, NZ, AMEM(IPZ), IZ, JZ, DESCZ, 0, 0, 'Z',
     $               NPR, AMEM( IPW ) )
      GO TO 23
*
   19 CALL PDLAPRNT( N, N, AMEM(IPZ), IZ, JZ, DESCZ, 0, 0, 'Z',
     $               NPR, AMEM( IPW ) )
      GO TO 23
*
*     
*
   23 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         WRITE(NOUT, FMT = *)'   '
         WRITE(NOUT, FMT = *)' '
*
      IF( NAME .NE. 'PDSYEV4' .AND. NAME .NE. 'PDSYEV6' ) GOTO 22
         WRITE(NOUT, FMT = *) NZ, 1
         DO 21 I = 1, NZ
            WRITE( NOUT, FMT = * ) AMEM( IPEV+I-1 )
   21    CONTINUE
      GO TO 28
*
   22    WRITE(NOUT, FMT = *) N, 1
         DO 27 I = 1, N
            WRITE( NOUT, FMT = * ) AMEM( IPEV+I-1 )
   27    CONTINUE
*
   28    WRITE(NOUT, FMT = *)' '
      END IF
*
      IF( NAME .NE. 'PDSYEV4' .AND. NAME .NE. 'PDSYEV6' ) GOTO 25
*
      CALL PDLAWRITE( OUTFILE, N, NZ, AMEM(IPZ), 1, 1, DESCZ,
     $                0, 0, AMEM(IPW) )
      GO TO 10
*
   25 CALL PDLAWRITE( OUTFILE, N, N, AMEM(IPZ), 1, 1, DESCZ,
     $                0, 0, AMEM(IPW) )
*
   10 CONTINUE
*
      CALL BLACS_GRIDEXIT( CTXT )
   20 CONTINUE
*
      IF( IAM .EQ. 0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
      CALL BLACS_EXIT( 0 )
*
 9992 FORMAT( / '    ', A7 )
 9998 FORMAT(/'     ,',//,
     $       '  A -  ',I2,'  ',I2,',',
     $       /'         ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       '    ', I2, '  ', I2 /)
 9995 FORMAT( / '  INFO =', I6, '    UPLO  = ', A1 /)
* 9996 FORMAT( / '  INFO  = ', I6 /)
      STOP
      END
